#                                                     -*- Makefile -*-
# Copyright (c) 1999, 2000  Motoyuki Kasahara
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

#
# :  Makefile ҤϡGNU make Ǥʤޤ
#

# ΥեΥС
FPWUTILS_MK_VERSION = 1.1

# Bourne ߴ
SHELL = /bin/sh

# Makefile ǵư륹ץȷ֤Ƥǥ쥯ȥ
ifndef FPWLIBEXECDIR
FPWLIBEXECDIR = /usr/local/libexec/freepwing
endif

# ȥե񤭹ǥ쥯ȥ
ifndef WORKDIR
WORKDIR = work
endif

# perl ޥ
ifndef PERL
PERL = ${FPWLIBEXECDIR}/perl.sh
endif

# perl ޥɤϤ *.pm եθץ
ifndef PERLINCFLAGS
PERLINCFLAGS = 
endif

# perl ޥɤϤ
ifndef PERLFLAGS
PERLFLAGS = 
endif

# fpwhalfchar ޥ
ifndef FPWHALFCHAR
FPWHALFCHAR = ${FPWLIBEXECDIR}/fpwhalfchar
endif

# fpwhalfchar ޥɤϤե
ifndef HALFCHARS
HALFCHARS = 
endif

# fpwfullchar ޥ
ifndef FPWFULLCHAR
FPWFULLCHAR = ${FPWLIBEXECDIR}/fpwfullchar
endif

# fpwhalfchar ޥɤϤե
ifndef FULLCHARS
FULLCHARS = 
endif

# ѡޥ
# (̾桼¦ Makefile Ǿ񤭤롣)
ifndef FPWPARSER
FPWPARSER = ${FPWLIBEXECDIR}/fpwparser
endif

# ѡޥɤϤ
# (̾桼¦ Makefile Ǿ񤭤롣)
ifndef FPWPARSERFLAGS
FPWPARSERFLAGS = 
endif

# fpwsort ֥ޥ
ifndef FPWSORT
FPWSORT = ${FPWLIBEXECDIR}/fpwsort
endif

# fpwindex ֥ޥ
ifndef FPWINDEX
FPWINDEX = ${FPWLIBEXECDIR}/fpwindex
endif

# fpwcontrol ֥ޥ
ifndef FPWCONTROL
FPWCONTROL = ${FPWLIBEXECDIR}/fpwcontrol
endif

# fpwlink ֥ޥ
ifndef FPWLINK
FPWLINK = ${FPWLIBEXECDIR}/fpwlink
endif

# mkdirhier ޥ
ifndef MKDIRHIER
MKDIRHIER = ${FPWLIBEXECDIR}/mkdirhier
endif

# cphier ޥ
ifndef CPHIER
CPHIER = ${FPWLIBEXECDIR}/cphier
endif

# make οʹԤϿե뷲
ifndef USERCHAR_DEP
USERCHAR_DEP = ${WORKDIR}/userchar.dep
endif
ifndef PARSE_DEP
PARSE_DEP = ${WORKDIR}/parse.dep
endif
ifndef SORT_DEP
SORT_DEP = ${WORKDIR}/sort.dep
endif
ifndef INDEX_DEP
INDEX_DEP = ${WORKDIR}/index.dep
endif
ifndef CONTROL_DEP
CONTROL_DEP = ${WORKDIR}/control.dep
endif
ifndef LINK_DEP
LINK_DEP = ${WORKDIR}/link.dep
endif

# gzip ޥ
ifndef GZIPCMD
GZIPCMD = gzip
endif

# zip ޥ
ifndef ZIP
ZIP = zip
endif

# catdump ޥ
ifndef CATDUMP
CATDUMP = catdump
endif

# ϥǡե뷲
# (̾桼¦ Makefile ꤵ롣)
ifndef SOURCES
SOURCES = 
endif

# ѥå̾
# (̾桼¦ Makefile ꤵ롣)
ifndef PACKAGE
PACKAGE = package
endif

# ҤΥǥ쥯ȥ̾
# (̾桼¦ Makefile ꤵ롣)
ifndef DIR
DIR = subdir
endif

# Хʥѥåźդե
# (̾桼¦ Makefile ꤵ롣)
ifndef PACKAGEEXTRA
PACKAGEEXTRA = 
endif

# ֤źդե
# (̾桼¦ Makefile ꤵ롣)
ifndef ARCHIVEEXTRA
ARCHIVEEXTRA = 
endif

# clean ¹Ի˰˺ե
# (̾桼¦ Makefile ꤵ롣)
ifndef CLEANEXTRA
CLEANEXTRA = 
endif

# 󥹥ȡΥǥ쥯ȥ
ifndef INSTALLDIR
INSTALLDIR = /usr/local/share/doc/dict
endif

#
# 롼
#
.PHONY: all parse sort index control link clean package install archive
.PHONY: parse-recursive sort-recursive index-recursive control-recursive \
	link-recursive clean-recursive
.PHONY: clean-directory install-directory archive-directory

all: link

ifneq ($(strip ${SUBDIRS}),)
userchar: userchar-recursive
parse: parse-recursive
sort: sort-recursive
index: index-recursive
control: control-recursive
link: link-recursive
clean: clean-recursive clean-directory
else
userchar: ${USERCHAR_DEP}
parse: ${PARSE_DEP}
sort: ${SORT_DEP}
index: ${INDEX_DEP}
control: ${CONTROL_DEP}
link: ${LINK_DEP}
clean: clean-directory
endif

${USERCHAR_DEP}: ${HALFCHARS} ${FULLCHARS}
	@rm -f ${USERCHAR_DEP}
	test -d ${WORKDIR} || ${MKDIRHIER} ${WORKDIR}
	${PERL} ${PERLINCFLAGS} ${PERLFLAGS} ${FPWHALFCHAR} \
	   -workdir ${WORKDIR} ${HALFCHARS}
	${PERL} ${PERLINCFLAGS} ${PERLFLAGS} ${FPWFULLCHAR} \
	   -workdir ${WORKDIR} ${FULLCHARS}
	@echo timestamp > ${USERCHAR_DEP}

${PARSE_DEP}: ${USERCHAR_DEP} ${SOURCES}
	@rm -f ${PARSE_DEP}
	${PERL} ${PERLINCFLAGS} ${PERLFLAGS} ${FPWPARSER} \
	   -workdir ${WORKDIR} ${FPWPARSERFLAGS}
	@echo timestamp > ${PARSE_DEP}

${SORT_DEP}: ${PARSE_DEP}
	@rm -f ${SORT_DEP}
	${PERL} ${PERLINCFLAGS} ${PERLFLAGS} ${FPWSORT} -workdir ${WORKDIR} 
	@echo timestamp > ${SORT_DEP}

${INDEX_DEP}: ${SORT_DEP}
	@rm -f ${INDEX_DEP}
	${PERL} ${PERLINCFLAGS} ${PERLFLAGS} ${FPWINDEX} -workdir ${WORKDIR} 
	@echo timestamp > ${INDEX_DEP}

${CONTROL_DEP}: ${INDEX_DEP}
	@rm -f ${CONTROL_DEP}
	${PERL} ${PERLINCFLAGS} ${PERLFLAGS} ${FPWCONTROL} -workdir ${WORKDIR}
	@echo timestamp > ${CONTROL_DEP}

${LINK_DEP}: ${CONTROL_DEP}
	@rm -f ${LINK_DEP}
	${PERL} ${PERLINCFLAGS} ${PERLFLAGS} ${FPWLINK} -workdir ${WORKDIR}
	@echo timestamp > ${LINK_DEP}

clean-directory:
	rm -rf ${WORKDIR}
	rm -rf ${PACKAGE}
	rm -f catalogs honmon ${CLEANEXTRA}
	rm -f ${PACKAGE}.tar.gz ${PACKAGE}.zip ${PACKAGE}-src.tar.gz

catalogs: catalogs.txt
	rm -f catalogs
	${CATDUMP} -u catalogs.txt catalogs

parse-recursive sort-recursive index-recursive control-recursive \
link-recursive clean-recursive:
	target=`echo $@ | sed s/-recursive//`; \
	for subdir in ${SUBDIRS} ; do \
	   ${MAKE} -C $$subdir $$target ; \
	done

package:
	rm -rf ${DIR}
	rm -f ${PACKAGE}.tar.gz
	rm -f ${PACKAGE}.zip
	${MAKE} INSTALLDIR="." DIR="${DIR}" install
	chmod 777 ${DIR}
ifneq ($(strip ${SUBDIRS}),)
	for subdir in ${SUBDIRS} ; do \
	   chmod 777 ${DIR}/$${subdir}/data ; \
	done
else
	chmod 777 ${DIR}/${DIR}/data
endif
	tar cf - ${DIR} | ${GZIPCMD} -9 > ${PACKAGE}.tar.gz
	${ZIP} -9rkq ${PACKAGE}.zip ${DIR}
	rm -rf ${DIR}

install: all catalogs
	${MKDIRHIER} ${INSTALLDIR}/${DIR}
	for file in catalogs ; do \
	   ${CPHIER} $$file ${INSTALLDIR}/${DIR}/$$file ; \
	done
ifneq ($(strip ${SUBDIRS}),)
	for subdir in ${SUBDIRS} ; do \
	   case ${INSTALLDIR} in \
	   /*) ${MAKE} -C $$subdir \
	       INSTALLDIR="${INSTALLDIR}/${DIR}/$$subdir" \
	       install-directory ;; \
	   *)  ${MAKE} -C $$subdir \
	       INSTALLDIR="../${INSTALLDIR}/${DIR}/$$subdir" \
	       install-directory ;; \
	   esac ; \
	done
else
	${MAKE} INSTALLDIR="${INSTALLDIR}/${DIR}/${DIR}" install-directory
endif
	packageextra='${PACKAGEEXTRA}' ; \
	for file in $$packageextra ; do \
	   case $$file in \
	   *=*) srcfile="`echo $$file | sed 's/=.*//'`" ; \
	        dstfile="`echo $$file | sed 's/.*=//'`" ; \
	        ${MAKE} $$srcfile ; \
	           ${CPHIER} $$srcfile ${INSTALLDIR}/${DIR}/$$dstfile ;; \
	   *)   ${MAKE} $$file ; \
	           ${CPHIER} $$file ${INSTALLDIR}/${DIR}/$$file ;; \
	   esac ; \
	done

install-directory:
	${MKDIRHIER} ${INSTALLDIR}/data
	for file in honmon ; do \
	   ${CPHIER} $$file ${INSTALLDIR}/data/$$file ; \
	done
	${MKDIRHIER} ${INSTALLDIR}/gaiji
	for file in gai16h gai24h gai30h gai48h gai16f gai24f gai30f gai48f ; do \
	   if test -f $$file ; then \
	      ${CPHIER} $$file ${INSTALLDIR}/gaiji/$$file ; \
	   fi ; \
	done

archive:
	rm -rf ${PACKAGE}
	rm -f ${PACKAGE}-src.tar.gz
	${MKDIRHIER} ${PACKAGE}
	chmod 777 ${PACKAGE}
ifneq ($(strip ${SUBDIRS}),)
	for subdir in ${SUBDIRS} ; do \
	   ${MAKE} -C $$subdir ARCHIVEDIR="../${PACKAGE}/$$subdir" \
	      archive-directory ; \
	   chmod 777 ${PACKAGE}/$${subdir} ; \
	done
endif
	${MAKE} ARCHIVEDIR="${PACKAGE}" archive-directory
	tar cf - ${PACKAGE} | gzip -9 > ${PACKAGE}-src.tar.gz
	rm -rf ${PACKAGE}

archive-directory:
	for file in README Makefile catalogs.txt ${FPWPARSER} ; do \
	   if test -f $$file ; then \
	      ${CPHIER} $$file ${ARCHIVEDIR}/$$file ; \
	   fi ; \
	done
	archiveextra='${ARCHIVEEXTRA}' ; \
	for file in $$archiveextra ; do \
	   case $$file in \
	   *=*) srcfile="`echo $$file | sed 's/=.*//'`" ; \
	        dstfile="`echo $$file | sed 's/.*=//'`" ; \
	        ${CPHIER} $$srcfile ${ARCHIVEDIR}/$$dstfile ;; \
	   *)   ${CPHIER} $$file ${ARCHIVEDIR}/$$file ;; \
	   esac ; \
	done

.SUFFIXES:

#
# С [3.59, 3.63)  GNU make Фơ٤Ƥѿ export
# ʤ褦˻ؼ롣ʤȡƥ (ʤȤ SysV) 
# ͤۤƤޤ
#
.NOEXPORT:
